//
// ePuckBehavior.mm
//
// Automatically created through MiCASE -- do not change manually!
//
#include "ePuckBehavior_Includes.h"
#include "ePuckBehavior.h"

#include "State_INITIAL.h"
#include "State_WALK_STRAIGHT.h"
#include "State_STOP.h"
#include "State_SPIN.h"

using namespace FSM;
using namespace CLM;

extern "C"
{
	ePuckBehavior *CLM_Create_ePuckBehavior(int mid, const char *name)
	{
		return new ePuckBehavior(mid, name);
	}
}

ePuckBehavior::ePuckBehavior(int mid, const char *name): CLMachine(mid, name)
{
	_states[0] = new FSMePuckBehavior::State::INITIAL;
	_states[1] = new FSMePuckBehavior::State::WALK_STRAIGHT;
	_states[2] = new FSMePuckBehavior::State::STOP;
	_states[3] = new FSMePuckBehavior::State::SPIN;

	setInitialState(_states[0]);            // set initial state
}

ePuckBehavior::~ePuckBehavior()
{
	delete _states[0];
	delete _states[1];
	delete _states[2];
	delete _states[3];
}
